library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity counter is
	Port(
		clock : in STD_LOGIC;
		clear : in STD_LOGIC;
		count : in STD_LOGIC;
		q : out STD_LOGIC_VECTOR (15 downto 0)
		);
end counter;

architecture Behavioral of counter is
signal Pre_Q: std_logic_vector(15 downto 0);
begin

    process(clock, count, clear)
    begin
		if clear = '1' then
			Pre_Q <= "0000000000000000";
		elsif (clock='1' and clock'event) then
			if count = '1' then
				Pre_Q <= Pre_Q + 1;
			end if;
		end if;
	end process;
	
	q <= Pre_Q;
end Behavioral;

