----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    18:04:40 03/08/2010 
-- Design Name: 
-- Module Name:    unpack - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity unpack is
	Port(
		input : in STD_LOGIC_VECTOR (15 downto 0);
		output : out STD_LOGIC_VECTOR (7 downto 0)
		);
end unpack;

architecture Behavioral of unpack is

component Adder is
	Port(
		a : in STD_LOGIC_VECTOR (7 downto 0);
		b : in STD_LOGIC_VECTOR (7 downto 0);
		cin : in STD_LOGIC;

		f : out STD_LOGIC_VECTOR (7 downto 0);
		add_cout : out STD_LOGIC
		);
end component;

signal shift1 : STD_LOGIC_VECTOR (7 downto 0);
signal shift2 : STD_LOGIC_VECTOR (7 downto 0);
signal shift3 : STD_LOGIC_VECTOR (7 downto 0);
signal shift4 : STD_LOGIC_VECTOR (7 downto 0);
signal shift5 : STD_LOGIC_VECTOR (7 downto 0);
signal shift6 : STD_LOGIC_VECTOR (7 downto 0);
signal shift7 : STD_LOGIC_VECTOR (7 downto 0);
signal shift8 : STD_LOGIC_VECTOR (7 downto 0);


signal rshift1 : STD_LOGIC_VECTOR (7 downto 0);
signal rshift2 : STD_LOGIC_VECTOR (7 downto 0);
signal rshift3 : STD_LOGIC_VECTOR (7 downto 0);
signal rshift4 : STD_LOGIC_VECTOR (7 downto 0);
signal rshift5 : STD_LOGIC_VECTOR (7 downto 0);
signal rshift6 : STD_LOGIC_VECTOR (7 downto 0);
signal rshift7 : STD_LOGIC_VECTOR (7 downto 0);
signal rshift8 : STD_LOGIC_VECTOR (7 downto 0);

signal three1 : STD_LOGIC_VECTOR (7 downto 0);
signal three2 : STD_LOGIC_VECTOR (7 downto 0);
signal three3 : STD_LOGIC_VECTOR (7 downto 0);
signal three4 : STD_LOGIC_VECTOR (7 downto 0);
signal three5 : STD_LOGIC_VECTOR (7 downto 0);
signal three6 : STD_LOGIC_VECTOR (7 downto 0);
signal three7 : STD_LOGIC_VECTOR (7 downto 0);
signal three8 : STD_LOGIC_VECTOR (7 downto 0);


signal gshift1low : STD_LOGIC;
signal gshift2low : STD_LOGIC;
signal gshift3low : STD_LOGIC;
signal gshift4low : STD_LOGIC;
signal gshift5low : STD_LOGIC;
signal gshift6low : STD_LOGIC;
signal gshift7low : STD_LOGIC;
signal gshift8low : STD_LOGIC;

signal gshift1high : STD_LOGIC;
signal gshift2high : STD_LOGIC;
signal gshift3high : STD_LOGIC;
signal gshift4high : STD_LOGIC;
signal gshift5high : STD_LOGIC;
signal gshift6high : STD_LOGIC;
signal gshift7high : STD_LOGIC;
signal gshift8high : STD_LOGIC;



signal cin : STD_LOGIC;
signal cout3 : STD_LOGIC;
signal cout4 : STD_LOGIC;
signal cout5 : STD_LOGIC;
signal cout6 : STD_LOGIC;
signal cout7 : STD_LOGIC;
signal cout8 : STD_LOGIC;
begin
	cin <= '0';

	shift1(0) <= input(7);
	shift1(1) <= '0';
	shift1(2) <= '0';
	shift1(3) <= '0';
	shift1(4) <= '0';
	shift1(5) <= '0';
	shift1(6) <= '0';
	shift1(7) <= '0';
	gshift1high <= '0';
	gshift1low <= '0';
	
	shift2(0) <= input(6);
	shift2(1) <= shift1(0);
	shift2(2) <= '0';
	shift2(3) <= '0';
	shift2(4) <= '0';
	shift2(5) <= '0';
	shift2(6) <= '0';
	shift2(7) <= '0';
	gshift2high <= '0';
	gshift2low <= '0';

	shift3(0) <= input(5);
	shift3(1) <= shift2(0);
	shift3(2) <= shift2(1);
	shift3(3) <= '0';
	shift3(4) <= '0';
	shift3(5) <= '0';
	shift3(6) <= '0';
	shift3(7) <= '0';
	gshift3high <= '0';
	gshift3low <= (shift3(0) and shift3(2)) or (shift3(2) and shift3(1)) or shift3(3);
	
	adder3: Adder
		port map (shift3, three3, cin, rshift3, cout3);	

	shift4(0) <= input(4);
	shift4(1) <= shift3(0);
	shift4(2) <= shift3(1);
	shift4(3) <= shift3(2);
	shift4(4) <= '0';
	shift4(5) <= '0';
	shift4(6) <= '0';
	shift4(7) <= '0';
	gshift4high <= '0';
	gshift4low <= (shift4(0) and shift4(2)) or (shift4(2) and shift4(1)) or shift4(3);
	
	three4(0) <= gshift4low;
	three4(1) <= gshift4low;
	three4(2) <= '0';
	three4(3) <= '0';
	three4(4) <= '0';
	three4(5) <= '0';
	three4(6) <= '0';
	three4(7) <= '0';
	adder4: Adder
		port map (shift4, three4, cin, rshift4, cout4);	
	
	
	shift5(0) <= input(3);
	shift5(1) <= rshift4(0);
	shift5(2) <= rshift4(1);
	shift5(3) <= rshift4(2);
	shift5(4) <= rshift4(3);
	shift5(5) <= '0';
	shift5(6) <= '0';
	shift5(7) <= '0';
	gshift5high <= '0';
	gshift5low <= (shift5(0) and shift5(2)) or (shift5(2) and shift5(1)) or shift5(3);
	
	three5(0) <= gshift5low;
	three5(1) <= gshift5low;
	three5(2) <= '0';
	three5(3) <= '0';
	three5(4) <= '0';
	three5(5) <= '0';
	three5(6) <= '0';
	three5(7) <= '0';
	adder5: Adder
		port map (shift5, three5, cin, rshift5, cout5);	
	
	shift6(0) <= input(2);
	shift6(1) <= rshift5(0);
	shift6(2) <= rshift5(1);
	shift6(3) <= rshift5(2);
	shift6(4) <= rshift5(3);
	shift6(5) <= rshift5(4);
	shift6(6) <= '0';
	shift6(7) <= '0';
	gshift6high <= '0';
	gshift6low <= (shift6(0) and shift6(2)) or (shift6(2) and shift6(1)) or shift6(3);

	three6(0) <= gshift6low;
	three6(1) <= gshift6low;
	three6(2) <= '0';
	three6(3) <= '0';
	three6(4) <= '0';
	three6(5) <= '0';
	three6(6) <= '0';
	three6(7) <= '0';
	adder6: Adder
		port map (shift6, three6, cin, rshift6, cout6);	
	
	shift7(0) <= input(1);
	shift7(1) <= rshift6(0);
	shift7(2) <= rshift6(1);
	shift7(3) <= rshift6(2);
	shift7(4) <= rshift6(3);
	shift7(5) <= rshift6(4);
	shift7(6) <= rshift6(5);
	shift7(7) <= '0';
	gshift7high <= (shift7(4) and shift7(6))or (shift7(6) and shift7(5)) or shift7(7);
	gshift7low <= (shift7(0) and shift7(2)) or (shift7(2) and shift7(1)) or shift7(3);
	
	three7(0) <= gshift7low;
	three7(1) <= gshift7low;
	three7(2) <= '0';
	three7(3) <= '0';
	three7(4) <= '0';
	three7(5) <= gshift7high;
	three7(6) <= gshift7high;
	three7(7) <= '0';
	adder7: Adder
		port map (shift7, three7, cin, rshift7, cout7);	
	
	shift8(0) <= input(0);
	shift8(1) <= rshift7(0);
	shift8(2) <= rshift7(1);
	shift8(3) <= rshift7(2);
	shift8(4) <= rshift7(3);
	shift8(5) <= rshift7(4);
	shift8(6) <= rshift7(5);
	shift8(7) <= rshift7(6);
	gshift8high <= (shift8(4) and shift8(6)) or shift8(7);
	gshift8low <= (shift8(0) and shift8(2)) or shift8(3);
	
	three8(0) <= gshift8low;
	three8(1) <= gshift8low;
	three8(2) <= '0';
	three8(3) <= '0';
	three8(4) <= '0';
	three8(5) <= gshift8high;
	three8(6) <= gshift8high;
	three8(7) <= '0';
	adder8: Adder
		port map (shift8, three8, cin, rshift8, cout8);	
	
	output <= shift8;
end Behavioral;

